var app = (function () {
  var documentRoot = localStorage.getItem('documentRoot');
  var isDebug = false;
  var mobileInfo = false;
  var noop = function(){};
  var hproseClient = null;

  /**
   * @description 获取角色登录token
   */
  function getUserToken() {
    var userToken = false;
    var jsonUserStr = localStorage.getItem('token');
    if(jsonUserStr) userToken = JSON.parse(jsonUserStr);
 		return userToken;
  };

  // 自动登录
  function reLogin(path, data, callback) {
    return false;
  }

  // 初始化网络信息和用户登录信息
  function init() {
    isDebug = (plus && plus.runtime.appid.toLowerCase() == 'hbuilder');
    if( typeof hprose != 'undefined') {
      hproseClient = hprose.Client.create(documentRoot, ['User_getConf']);
      function addToken(name, args, context, next) {
        args = (args.length > 0)?[{data:args}]:[{}];
        var userToken = getUserToken();
        if(userToken) {
          if (userToken.hasOwnProperty('token')) args[0]['token'] = userToken['token'];
          if (userToken.hasOwnProperty('userId')) args[0]['userId'] = userToken['userId'];
        }
        var result = next(name, args, context);
        return result;
      }
      hproseClient.use(addToken);
      function log(data) {
        console.log('send '+data);
        return data;
      }
      hproseClient.addFilter({ inputFilter: log, outputFilter: log});
    }
  };

  // 协议异常处理
  function showErr(call, err) {
    console.log(call + JSON.stringify(err) );
  }
  var owner = {};
  owner.initRoot = function() {
  	documentRoot = localStorage.getItem('documentRoot');
  	init();
  };
  owner.isDebug = function () {
  	var isDebug = undefined;
  	return function() {
  		if(undefined == isDebug) {
    		isDebug = (plus && plus.runtime.appid.toLowerCase() == 'hbuilder');
  		}
    return isDebug;
  	}
  }();
  // 登录后获取网络数据
  owner.netCall = function (path, data, callback) {
    if(typeof callback != 'function') callback = noop;
    if(!hproseClient) return this.ajaxCall(path, data, callback);

    hproseClient.invoke(path, data).then(function (resp) {
      return callback(resp);
    },showErr);
  };
  
  //所有图片剪裁
  owner.pictureClipping = function(ClippingNum){
		var offsetWidth = document.querySelector('.'+ClippingNum).parentNode.offsetWidth;
		var offsetHeight = document.querySelector('.'+ClippingNum).parentNode.offsetHeight;
		mui.each(document.querySelectorAll('.'+ClippingNum),function(ind, node) {
			if(node.getAttribute('data-img-cliped') ) return;
			node.onload = function(){
				var c=document.createElement("canvas");
				c.style.display="none";
				c.width=node.width; 
				c.height=node.height;
				var ctx=c.getContext("2d");
				ctx.drawImage(node, 0,0); 
				var w = offsetWidth*2;
				var h = offsetHeight*2;
				var imgData=ctx.getImageData((node.width-w)/2, (node.height-h)/2,w,h);
				c.width = w;
				c.height = h;
				ctx.putImageData(imgData,0,0);
				node.src = c.toDataURL('image/png');
				node.setAttribute('data-img-cliped', true);
				node.style.display = "block";
				node.onload = null;
				c = null;
				ctx = null;
			};
			node.src = node.getAttribute('data-img-origan');
		});
	}
  
  /**
   * @description 获取网络数据
   */
  owner.ajaxCall = function (path, args, callback) {
    args = (args && args.length > 0)?{data:args}:{};
    var userToken = getUserToken();
    if (userToken) {
      if (userToken.hasOwnProperty('token')) args['token'] = userToken['token'];
      if (userToken.hasOwnProperty('userId')) args['userId'] = userToken['userId'];
    }
    mui.post(documentRoot + '/' + path, args, function(resp) { return callback(resp); }, 'json');
  };
  owner.netCallWithNoLogin = this.netCall;

  // 获取用户信息
  owner.getUserInfo = function (callback) {
    var needLoad = false;
    var storageStr = localStorage.getItem('user');
    if(!storageStr) needLoad = true;
    if(!needLoad) return callback(JSON.parse(storageStr) );
    app.netCall('User_getUserInfo', [], function (resp) {
      if(!resp.ret.code) localStorage.setItem('user', JSON.stringify(resp.user) );
      callback(resp);
    });
  };

  // 加载银行卡信息
  owner.loadBankCard = function(callback) {
    var storageStr = localStorage.getItem('bank-card');
    if(storageStr) return callback(JSON.parse(storageStr) );
    if (!storageStr) {
      app.netCall('/User/getBankCard', null, function (resp) {
        if(!resp.ret) localStorage.setItem('bank-card', JSON.stringify(resp) );
        callback(resp);
      });
    }
  };
  // 加载货币信息
  owner.loadMoney = function(callback) {
    var needLoad = false;
    var storageStr = localStorage.getItem('money');
    if(!storageStr) needLoad = true;
    if(!needLoad) {
    	var nextLoad = localStorage.getItem('money_n');
    	var nowTime = new Date().getTime();
    	if(nowTime >= nextLoad) needLoad = true;
    }
    if(!needLoad) return callback(JSON.parse(storageStr) );
		app.netCall('/money', null, function (resp) {
      if(!resp.ret) {
      	localStorage.setItem('money', JSON.stringify(resp) );
      	localStorage.setItem('money_n', new Date().getTime() + 3000);
      }
      callback(resp);
    });
  };
  // 检查登录状态
  owner.checkLogin = function () {
    var user = localStorage.getItem('token');
    return user?true:false;
  };
  // 锁定dom
  owner.lockDom = function(dom) {
    var lastTap = dom.getAttribute('data-last-tap');
    var timeNow = new Date().getTime();
    if(lastTap && ((parseInt(lastTap) + 1000) > timeNow) ) return false;
    dom.setAttribute('data-last-tap', timeNow + '');
    return true;
  };
  // 打开应用
  owner.beforeOpen = function() {
    localStorage.removeItem('money');
    localStorage.removeItem('bank-card');
  };
  // 注销
  owner.clean = function () {
    localStorage.removeItem('user');
    localStorage.removeItem('money');
    localStorage.removeItem('bank-card');
    localStorage.removeItem('token');
    plus.storage.removeItem('user');
  };
  // 重新加载货贝数据
  owner.reloadMoney = function () {
    localStorage.removeItem('money');
  };
  // 重新加载银行卡
  owner.reloadBankCard = function () {
    localStorage.removeItem('bank-card');
  };
  // 重新加载用户数据
  owner.reloadUser = function () {
    localStorage.removeItem('user');
    localStorage.setItem('user_t', new Date().getTime());
  };
  // 显示剩余时间字符串
  owner.showEndTime = function (serverDate) {
    var val;
    if(serverDate.date) {
      //把时间中得‘-’换成‘/’
      //计算时间差，以小时为单位
      val = new Date(serverDate["date"].replace(/-/g, "/").replace(/\..*$/, "+0"));
    }
    else {
      val = new Date(serverDate * 1000);
    }

    var nowDate = new Date();
    var diffMinute = Math.floor(val.getTime() - nowDate.getTime()) / 60000;
    if ((diffMinute > 60) || (diffMinute < -60)) {
      var diffHour = Math.floor(diffMinute / 60);
      // diffMinute = diffMinute % 60;
      // return hour + ':' + minute;
      return diffHour + '小时';
    }
    else {
      return diffMinute + '分钟';
    }
  };

  // 货币转换
  owner.showServerMoney = function(val) {
    return Math.floor(val) / 100;
  };
  owner.showTextMsg = function(val) {
    var templateStr = appTextMsg[val['ind'] ];
    for(var key in val) {
      if('ind' == key) continue;
      if('object' ==  (typeof val[key]).toLowerCase() ) {
        templateStr = templateStr.replace(new RegExp('{'+key+'}', "gi"), app.showTextMsg(val[key]) );
      }
      else {
        templateStr = templateStr.replace(new RegExp('{'+key+'}', "gi"), val[key]);
      }
    }
    return templateStr;
  };
  // 服务器时间转换
  owner.showServerTime = function (val, onlyDate) {
    if (!val) return '';
    var dtVal;
    if(val.date) {
      dtVal = new Date(val.date.replace(/-/g, "/").replace(/\..*$/, " +0") );
    }
    else {
      dtVal= new Date(parseInt(val) * 1000);
    }
    var fullYear = dtVal.getFullYear();
    var fullMonth = ('0' + (1 + dtVal.getMonth() ) ).substr(-2);
    var fullDate = ('0' + dtVal.getDate() ).substr(-2);
    var ret = fullYear + '-' + fullMonth + '-' + fullDate;
    if (!onlyDate) {
      var fullHour = ('0' + dtVal.getHours() ).substr(-2);
      var fullMinute = ('0' + dtVal.getMinutes() ).substr(-2);
      var fullSecond = ('0' + dtVal.getSeconds() ).substr(-2);
      ret += ' ' + fullHour + ':' + fullMinute + ':' + fullSecond;
    }
    return ret;
  };
  // 获取分享服务列表
  owner.getShareServices = function () {
    var shareList = {};
    return function () {
      if (mui.isEmptyObject(shareList)) {
        plus.share.getServices(function (s) {
          for (var i in s) {
            var t = s[i];
            shareList[t.id] = t;
          }
        }, function (e) {
          plus.nativeUI.toast("获取分享服务列表失败：" + e.message);
        });
      }
      return shareList;
    };
  }();
  // 获取分享服务配置
  owner.getShareConfig = function () {
    var shareConfig = [
      {id: "weixin", title: "分享给微信好友", scene: "WXSceneSession", type: 11},
      {id: "weixin", title: "分享到微信朋友圈", scene: "WXSceneTimeline", type: 15},
      {id: "qq", title: "分享到QQ", type: 12},
      {id: "sinaweibo", title: "分享到微博"}
//    {id: "weixin", title: "微信收藏", scene: "WXSceneFavorite", type: 10},
    ];
    var sharConfigMap = {};
    return function (typeArr) {
      if (mui.isArray(typeArr)) {
        if (mui.isEmptyObject(sharConfigMap)) {
          for (var ind = 0; ind < shareConfig.length; ++ind) {
            sharConfigMap[shareConfig[ind].type] = shareConfig[ind];
          }
        }
        var ret = [];
        for (var ind = 0; ind < typeArr.length; ++ind) {
          ret.push(sharConfigMap[typeArr[ind]]);
        }
        return ret;
      }
      return shareConfig;
    };
  }();
  // 放弃当前任务
  owner.giveUpTask = function () {
    app.netCall('/giveUpTask', [], function (data) {
      localStorage.removeItem('nowTask');
    });
  }
  // 获取当前任务
  owner.getNowTask = function () {
    var storageStr = localStorage.getItem('nowTask');
    if (storageStr) {
      var nowTaskInfo = JSON.parse(storageStr);
      var nowTime = new Date().getTime();

      // 超时放弃
      if (nowTime > nowTaskInfo.validTime) {
        owner.giveUpTask();
        return false;
      }

      return nowTaskInfo.taskId;
    }
    return false;
  }

  owner.viewTaskDetail = function (infoLink) {
    var infoWin = plus.webview.getWebviewById(infoLink);
    infoWin.loadURL(infoLink);
    infoWin.show();
  }
  if (window.plus) {
    setTimeout(function () {
      init();
    }, 0);
  } else {
    document.addEventListener("plusready", function () {
      init();
    });
  }

  // 下载wgt文件
  var wUpdateWait = null;
  var patchName = '';
  downWgt = function(patchData) {
    var patchList = patchData;
    function down() {
      var downUrl = patchList.shift();
      var prefixStart = downUrl.lastIndexOf('/');
      var prefixEnd = downUrl.lastIndexOf('.');
      patchName = ' ' + downUrl.substr(prefixStart + 1, prefixEnd - prefixStart - 1) + ' ';
      if (null == wUpdateWait) {
        wUpdateWait = plus.nativeUI.showWaiting("正在下载更新包" + patchName);
      }
      else {
        wUpdateWait.setTitle("正在下载更新包" + patchName);
      }
      var patchDownloader = plus.downloader.createDownload(downUrl, {filename: "_doc/update/"});
      patchDownloader.addEventListener("statechanged", function (download, status) {
        switch (download.state) {
          case 2:
            if (null == wUpdateWait) {
              wUpdateWait = plus.nativeUI.showWaiting("开始下载" + patchName);
            }
            else {
              wUpdateWait.setTitle("开始下载" + patchName);
            }
            break;
          case 3:
            var percent = download.downloadedSize / download.totalSize * 100;
            wUpdateWait.setTitle("下载 " + patchName + parseInt(percent) + "%");
            break;
          case 4:
            if (200 == status) {
              if (patchList.length > 0) {
                installWgt(download.filename, false);	  // 安装wgt包
                setTimeout(down, 0);
              }
              else {
                installWgt(download.filename, true);	  // 安装wgt包
              }
            }
            else {
              if (wUpdateWait) wUpdateWait.close();
              wUpdateWait = null;
              mui.toast('下载失败');
            }
            break;
        }
      });
      patchDownloader.start();
    }

    down();
  };
  // 更新应用资源
  installWgt = function(path, restart) {
    if (null == wUpdateWait) {
      wUpdateWait = plus.nativeUI.showWaiting("正安装更新" + patchName);
    }
    else {
      wUpdateWait.setTitle("正安装更新" + patchName);
    }
    plus.runtime.install(path, {}, function () {
      if (wUpdateWait) wUpdateWait.close();
      wUpdateWait = null;
      plus.nativeUI.alert("更新完成！", function () {
        if (restart) plus.runtime.restart();
      });
    }, function (e) {
      if (wUpdateWait) wUpdateWait.close();
      wUpdateWait = null;
      plus.nativeUI.alert("安装更新失败[" + e.code + "]：" + e.message);
    });
  };
  // 检查更新
  owner.checkUpdate = function() {
    // 获取需要更新的补丁列表
    var config = JSON.parse(localStorage.getItem('config')).conf;
    if (config && config.hasOwnProperty('patch') && config.hasOwnProperty('version')) {
      var btnArray = ['立即更新', '稍后再说'];
      mui.confirm("发现新版本：" + config.version, '理财男女', btnArray, function (e) {
        if (e.index == 0) downWgt(config.patch);	   // 下载升级包
      })
    }
  };

  owner.convertImgToBase64 = function (url, callback, outputFormat) {
    var canvas = document.createElement('canvas');
    var ctx = canvas.getContext('2d');
    var img = new Image;
    img.crossOrigin = 'Anonymous';
    img.onload = function(){
      canvas.height = img.height;
      canvas.width = img.width;
      ctx.drawImage(img,0,0);
      var dataURL = canvas.toDataURL(outputFormat || 'image/png');
      callback.call(this, dataURL);
// Clean up
      canvas = null;
    };
    img.src = url;
  };

  // 对Date的扩展，将 Date 转化为指定格式的String
  // 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，
  // 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)
  // 例子：
  // (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423
  // (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18
  Date.prototype.Format = function (fmt) { //author: meizz
    var o = {
      "M+": this.getMonth() + 1,                 //月份
      "d+": this.getDate(),                    //日
      "h+": this.getHours(),                   //小时
      "m+": this.getMinutes(),                 //分
      "s+": this.getSeconds(),                 //秒
      "q+": Math.floor((this.getMonth() + 3) / 3), //季度
      "S": this.getMilliseconds()             //毫秒
    };
    if (/(y+)/.test(fmt))
      fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
      if (new RegExp("(" + k + ")").test(fmt))
        fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
  };

  return owner;
})();