/**
 * Created by Administrator on 2016/4/8.
 */
/**
 * Created by Administrator on 2016/4/6.
 */
requirejs.config({
  //By default load any module IDs from js/lib
  baseUrl: 'js',
  shim: {
    'app': ['hprose']
  }
});


// Start the main app logic.
require(['mui', 'windef', 'util', 'app'], function (mui) {
  function openPage(url, save) {
    var keyUrl = url;
    if (!appWinList.hasOwnProperty(url)) keyUrl = util.md5(keyUrl);
    if (keyUrl == activePage) return false;
    var isNavPageDest = checkNavPage(keyUrl);

    var nowPage = appWinList[activePage];
    var pageInfo = appWinList[keyUrl];
    if (pageInfo.hasOwnProperty('mustLogin') && !app.checkLogin() ) return openPage('login.html');
    if (pageInfo.title) document.getElementById("title").innerHTML = pageInfo.title;
    //更换标题
    if (isNavPageDest) {
      document.querySelector('header>:first-child').style.display = 'none';
    }
    else {
      document.querySelector('header>:first-child').style.display = 'block';
    }
    var selfWin = plus.webview.currentWebview();//获取当前窗口的WebviewObject对象
    var destWin = plus.webview.getWebviewById(keyUrl);//查找指定标识的WebviewObject窗口
    var oldWin = plus.webview.getWebviewById(activePage);//查找指定标识的WebviewObject窗口
    console.log('67: ' + activePage + ' old win [' + (oldWin ? oldWin.id : '') + '] will be hide, ' + keyUrl + ' new win [' + (destWin ? destWin.id : 0) + '] will be show');
    if (!(destWin && (destWin.parent().id == selfWin.id) )) {
      console.log('69: ' + keyUrl + ' not loaded!');
      loadPage([keyUrl], keyUrl);
      destWin = plus.webview.getWebviewById(keyUrl);
    }
    else {
      if (pageInfo.hasChildLoad) {
        destWin.show();
      }
      else {
        appWinList[keyUrl]['hasChildLoad'] = true;
        if (appWinPreload.hasOwnProperty(keyUrl)) {
          destWin.show(null, null, function () {
            console.log(destWin.id + ' will load ' + JSON.stringify(appWinPreload[keyUrl]));
            loadPage(appWinPreload[keyUrl]);
          });
        }
        else {
          destWin.show();
        }
      }
    }
    if (oldWin) oldWin.hide();
    var saveHistory = nowPage.hasOwnProperty('save') ? nowPage.save : true;
    if (saveHistory && ((arguments.length > 1) && !save)) saveHistory = false;
    //更改当前活跃的选项卡
    if (saveHistory) historyPage.push(activePage);
    if (isNavPageDest) {
      historyPage = [];
      mui.qsa('.mui-active').forEach(function (node) {
        node.classList.remove('mui-active');
      });
      var destDom = document.querySelector('a[keyUrl="' + keyUrl + '"]');
      if (destDom) destDom.classList.add('mui-active')
    }
    activePage = keyUrl;
  }

  function checkNavPage(page) {
    return ['homeDetail.html', 'homeOpen.html', 'carriedOut.html', 'personalIndex.html'].indexOf(page) > -1;
  }

  // 管控子页面窗口
  window.addEventListener('openWin', function (event) {
    //获得事件参数
    var destUrl = event.detail.pageUrl;
    var keyUrl = util.md5(destUrl);
    console.log(JSON.stringify(event.detail));
    if (event.detail.hasOwnProperty('save')) {
      openPage(keyUrl, event.detail.save);
    }
    else {
      openPage(keyUrl);
    }
  });
  // 管控子页面窗口
  window.addEventListener('preLoad', function (event) {
    //获得事件参数
    loadPage(event.detail.pageUrl);
  });
  window.addEventListener('goBack', back);
  window.addEventListener('cleanHistory', function () {
    historyPage = [];
  });

  function back() {
    var activeView = plus.webview.getWebviewById(activePage);
    var isNavPage = checkNavPage(activePage);
    activeView.canBack(function (eve) {
      if (eve.canBack && !isNavPage) {
        console.log(activePage + ' sys back');
        activeView.back();
        return false;
      }
      else {
        if (isNavPage) {
          if (plus.android) plus.android.runtimeMainActivity().moveTaskToBack(false);
          return false;
        }
        if (historyPage.length > 0) {
          if (new Date().getTime() - lastBackTime < 1000) return false;
          lastBackTime = new Date().getTime();
          var lastUrl = historyPage.pop();
          setTimeout(function () {
            console.log(activePage + ' app back to ' + lastUrl);
            openPage(lastUrl, false);
            if (!(plus.webview.getWebviewById(lastUrl).isVisible() )) {
              console.log(activePage + ' ' + lastUrl);
            }
          });
          return false;
        }
        if ('homeDetail.html' != activePage) {
          console.log('app back to home');
          openPage('homeDetail.html', false);
          return false;
        }
        if (plus.android) plus.android.runtimeMainActivity().moveTaskToBack(false);
      }
    });
    return false;
  }

  // mui初始化
  mui.init({
    swipeBack: false,
    beforeback: back
  });
  mui.plusReady(function(){
	plus.navigator.setStatusBarBackground( "#E22323" );
	plus.navigator.setStatusBarStyle( "UIStatusBarStyleBlackOpaque" );
  })
  function loadSubPage(subWin, keyUrl) {
    var innerKeyUrl = keyUrl;
    var innerPage = subWin;
    return function () {
      innerPage.addEventListener('show', function handler() {
        console.log(subWin.id + ' will load ' + JSON.stringify(appWinPreload[keyUrl]));
        loadPage(appWinPreload[keyUrl]);
        innerPage.removeEventListener('show', handler);
      }, false);
    }
  }

  function loadPage(pages, showPage) {
    if (!(pages instanceof Array)) {
      var tmpUrl = util.md5(pages);
      if (appWinPreload[tmpUrl]) loadPage(appWinPreload[tmpUrl], showPage);
      return;
    }
    var self = plus.webview.currentWebview();
    for (var i = 0; i < pages.length; ++i) {
      var keyUrl = pages[i];
      if (!appWinList.hasOwnProperty(keyUrl)) keyUrl = util.md5(keyUrl);
      if (plus.webview.getWebviewById(keyUrl)) continue;		// 已经加载
      if (!appWinList[keyUrl]) continue;										// 未受控子页面

      var tmpWinInfo = appWinList[keyUrl];
      var sub = plus.webview.create(tmpWinInfo['url'], keyUrl, tmpWinInfo['style']);

      if (showPage != keyUrl) sub.hide();
      self.append(sub);
      console.log(keyUrl + ' Loaded in ' + self.id);
    }
  }

  // 创建子页面，首个选项卡页面显示，其它均隐藏；
  mui.plusReady(function () {
    console.log("创建子页面");
    loadPage(location.href, 'homeDetail.html');
  });
  // 当前可见页
  var activePage = util.md5('homeDetail.html');
  var lastBackTime = 0;
  // 历史记录
  var historyPage = [];
  //选项卡点击事件
  mui('.mui-bar-tab').on('tap', 'a', function (e) {

    var destUrl = this.getAttribute('keyUrl');
    if (!destUrl) {
      mui.toast('开发中...');
      return false;
    }
    
    if (destUrl == activePage) return false;
    openPage(destUrl);
    return true;
  });
});